# Class VulkanCommandPoolCreateInfo

java.lang.Object
com.io7m.jcoronado.api.VulkanCommandPoolCreateInfo

All Implemented Interfaces:
  `VulkanCommandPoolCreateInfoType`

public final class VulkanCommandPoolCreateInfo extends Object implements VulkanCommandPoolCreateInfoType
Structure specifying parameters of a newly created command pool.

See Also:
  - "VkCommandPoolCreateInfo"

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static final class`
  `VulkanCommandPoolCreateInfo.Builder`
  Builds instances of type `VulkanCommandPoolCreateInfo`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static VulkanCommandPoolCreateInfo.Builder`
  `builder()`
  Creates a builder for `VulkanCommandPoolCreateInfo`.
  `static VulkanCommandPoolCreateInfo`
  `copyOf(VulkanCommandPoolCreateInfoType instance)`
  Creates an immutable copy of a `VulkanCommandPoolCreateInfoType` value.
  `boolean`
  `equals(Object another)`
  This instance is equal to all instances of `VulkanCommandPoolCreateInfo` that have equal attribute values.
  `Set<VulkanCommandPoolCreateFlag>`
  `flags()`
  `int`
  `hashCode()`
  Computes a hash code from attributes: `flags`, `queueFamilyIndex`.
  `static VulkanCommandPoolCreateInfo`
  `of(Iterable<VulkanCommandPoolCreateFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex)`
  Construct a new immutable `VulkanCommandPoolCreateInfo` instance.
  `static VulkanCommandPoolCreateInfo`
  `of(Set<VulkanCommandPoolCreateFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex)`
  Construct a new immutable `VulkanCommandPoolCreateInfo` instance.
  `VulkanQueueFamilyIndex`
  `queueFamilyIndex()`
  `String`
  `toString()`
  Prints the immutable value `VulkanCommandPoolCreateInfo` with attribute values.
  `final VulkanCommandPoolCreateInfo`
  `withFlags(VulkanCommandPoolCreateFlag... elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanCommandPoolCreateInfo`
  `withFlags(Iterable<VulkanCommandPoolCreateFlag> elements)`
  Copy the current immutable object with elements that replace the content of `flags`.
  `final VulkanCommandPoolCreateInfo`
  `withQueueFamilyIndex(VulkanQueueFamilyIndex value)`
  Copy the current immutable object by setting a value for the `queueFamilyIndex` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Method Details

  - ### flags

    public Set<VulkanCommandPoolCreateFlag> flags()
    Specified by:
      `flags` in interface `VulkanCommandPoolCreateInfoType`
    Returns:
      Flags specifying how the command pool will be generated.

  - ### queueFamilyIndex

    public VulkanQueueFamilyIndex queueFamilyIndex()
    Specified by:
      `queueFamilyIndex` in interface `VulkanCommandPoolCreateInfoType`
    Returns:
      A queue family as described in section Queue Family Properties. All command buffers allocated from this command pool must be submitted on queues from the same queue family.

  - ### withFlags

    public final VulkanCommandPoolCreateInfo withFlags(VulkanCommandPoolCreateFlag... elements)
    Copy the current immutable object with elements that replace the content of `flags`.
    Parameters:
      `elements` - The elements to set
    Returns:
      A modified copy of `this` object

  - ### withFlags

    public final VulkanCommandPoolCreateInfo withFlags(Iterable<VulkanCommandPoolCreateFlag> elements)
    Copy the current immutable object with elements that replace the content of `flags`. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `elements` - An iterable of flags elements to set
    Returns:
      A modified copy of `this` object

  - ### withQueueFamilyIndex

    public final VulkanCommandPoolCreateInfo withQueueFamilyIndex(VulkanQueueFamilyIndex value)
    Copy the current immutable object by setting a value for the `queueFamilyIndex` attribute. A shallow reference equality check is used to prevent copying of the same value by returning `this`.
    Parameters:
      `value` - A new value for queueFamilyIndex
    Returns:
      A modified copy of the `this` object

  - ### equals

    public boolean equals(Object another)
    This instance is equal to all instances of `VulkanCommandPoolCreateInfo` that have equal attribute values.
    Overrides:
      `equals` in class `Object`
    Returns:
      `true` if `this` is equal to `another` instance

  - ### hashCode

    public int hashCode()
    Computes a hash code from attributes: `flags`, `queueFamilyIndex`.
    Overrides:
      `hashCode` in class `Object`
    Returns:
      hashCode value

  - ### toString

    public String toString()
    Prints the immutable value `VulkanCommandPoolCreateInfo` with attribute values.
    Overrides:
      `toString` in class `Object`
    Returns:
      A string representation of the value

  - ### of

    public static VulkanCommandPoolCreateInfo of(Set<VulkanCommandPoolCreateFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex)
    Construct a new immutable `VulkanCommandPoolCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `queueFamilyIndex` - The value for the `queueFamilyIndex` attribute
    Returns:
      An immutable VulkanCommandPoolCreateInfo instance

  - ### of

    public static VulkanCommandPoolCreateInfo of(Iterable<VulkanCommandPoolCreateFlag> flags, VulkanQueueFamilyIndex queueFamilyIndex)
    Construct a new immutable `VulkanCommandPoolCreateInfo` instance.
    Parameters:
      `flags` - The value for the `flags` attribute
      `queueFamilyIndex` - The value for the `queueFamilyIndex` attribute
    Returns:
      An immutable VulkanCommandPoolCreateInfo instance

  - ### copyOf

    public static VulkanCommandPoolCreateInfo copyOf(VulkanCommandPoolCreateInfoType instance)
    Creates an immutable copy of a `VulkanCommandPoolCreateInfoType` value. Uses accessors to get values to initialize the new immutable instance. If an instance is already immutable, it is returned as is.
    Parameters:
      `instance` - The instance to copy
    Returns:
      A copied immutable VulkanCommandPoolCreateInfo instance

  - ### builder

    public static VulkanCommandPoolCreateInfo.Builder builder()
    Creates a builder for `VulkanCommandPoolCreateInfo`.

         VulkanCommandPoolCreateInfo.builder()
            .addFlags|addAllFlags(com.io7m.jcoronado.api.VulkanCommandPoolCreateFlag) // flags elements
            .setQueueFamilyIndex(com.io7m.jcoronado.api.VulkanQueueFamilyIndex) // required queueFamilyIndex
            .build();

    Returns:
      A new VulkanCommandPoolCreateInfo builder